'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ancientFunicular = require('ancient-funicular');

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _dockerode = require('dockerode');

var _dockerode2 = _interopRequireDefault(_dockerode);

var _fs = require('fs');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Container = function (_Item) {
    _inherits(Container, _Item);

    function Container(options) {
        _classCallCheck(this, Container);

        var _this = _possibleConstructorReturn(this, (Container.__proto__ || Object.getPrototypeOf(Container)).call(this));

        _this._docker = null;

        if (_this._isObject(options)) {
            _this._docker = new _dockerode2.default(options);
        } else {
            var socket = process.env.DOCKER_SOCKET || '/var/run/docker.sock';
            var stats = (0, _fs.statSync)(socket);

            if (!stats.isSocket()) {
                throw new Error('Local service is not found.');
            }

            _this._docker = new _dockerode2.default({
                socketPath: socket
            });
        }
        return _this;
    }

    _createClass(Container, [{
        key: 'create',
        value: function create(options) {
            var self = this;

            if (!self._isString(options) && !self._isObject(options)) {
                throw new Error('The variable \'options\' is not correct.');
            }

            if (self._isString(options)) {
                var Image = options;
                options = { Image: Image };
            }

            self._pullImage(options.Image, function (error) {
                self._handlerError(error);
                self._createContainer(options);
            });
        }
    }, {
        key: 'destroy',
        value: function destroy() {}
    }, {
        key: '_pullImage',
        value: function _pullImage(image, callback) {
            var self = this;
            self._docker.pull(image).then(function (stream) {
                self._docker.modem.followProgress(stream, callback, self.debug);
            }).catch(function (error) {
                return self._handlerError(error);
            });
        }
    }, {
        key: '_createContainer',
        value: function _createContainer(options) {
            var self = this;
            self._docker.createContainer(options).then(function (container) {
                self.debug(container);
            }).catch(function (error) {
                return self._handlerError(error);
            });
        }
    }, {
        key: '_isString',
        value: function _isString(value) {
            return typeof value === 'string';
        }
    }, {
        key: '_isObject',
        value: function _isObject(value) {
            return (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object';
        }
    }, {
        key: '_handlerError',
        value: function _handlerError(error) {
            if (error) {
                throw new Error(error);
            }
        }
    }, {
        key: 'debug',
        value: function debug() {
            var args = Array.prototype.slice.call(arguments);
            var debug = (0, _debug2.default)('container');
            debug.apply(null, args);
        }
    }]);

    return Container;
}(_ancientFunicular.Item);

exports.default = Container;